var mozless_enabled;
var mozless_debug;
var mozless_focusMode;
var mozless_emacskeys;
var mozless_swapuandi;
var mozless_crossfire;

var mozless_sb;

var mozless_focusedFrameIndex;

var mozless_isFirefox = (mozless_getAppName() == "Firefox");


//mozless_init_settings(); // XXX moved in mozless_init()

function mozless_init_settings()
{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"]
		.getService(Components.interfaces.nsIPrefService)
		.getBranch("extensions.mozless.");

  mozless_enabled = mozless_getBoolPref(prefs, "enabled", true);
  mozless_debug = mozless_getBoolPref(prefs, "debug", false);
  mozless_focusMode = mozless_getBoolPref(prefs, "focusmode", false);
  mozless_emacskeys = mozless_getBoolPref(prefs, "emacskeys", false);
	mozless_swapuandi = mozless_getBoolPref(prefs, "swapuandi", false);
	mozless_crossfire = mozless_getBoolPref(prefs, "crossfire", false);

	if (mozless_enabled && mozless_getAppName() != "Firefox") {
		var prefs = Components.classes["@mozilla.org/preferences-service;1"]
			.getService(Components.interfaces.nsIPrefBranch);

		if (prefs.getBoolPref("accessibility.typeaheadfind.autostart") == true) {
			prefs.setBoolPref("accessibility.typeaheadfind.autostart", false);
			if (mozless_getAppName() != "Firefox")
				alert("mozless: "
					+ mozless_sb.GetStringFromName("autostart_is_suppressed")
					+ " (accessibility.typeaheadfind.autostart = false)");
		}
		if (prefs.getBoolPref("accessibility.typeaheadfind.linksonly") == true) {
			prefs.setBoolPref("accessibility.typeaheadfind.linksonly", false);
			alert("mozless: "
				+ mozless_sb.GetStringFromName("linksonly_is_suppressed")
				+ " (accessibility.typeaheadfind.linksonly = false)");
		}
	}

	if (mozless_enabled && mozless_crossfire) mozless_crossfire_update();
}

function mozless_crossfire_update()
{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"]
		.getService(Components.interfaces.nsIPrefService)
		//.getBranch("extensions.crossfire.");
		.getBranch("crossfire.");

	if (mozless_focusMode) {
		prefs.setBoolPref("enable", true);
		prefs.setBoolPref("usehjkl", true);
	} else {
		prefs.setBoolPref("enable", false);
		prefs.setBoolPref("usehjkl", true);
	}
}

function mozless_init(e) {
  var sbs = Components.classes["@mozilla.org/intl/stringbundle;1"].
    getService(Components.interfaces.nsIStringBundleService);
  mozless_sb = sbs.createBundle("chrome://mozless/locale/messages.properties");

	mozless_init_settings(); // XXX

	if (window._content.frames.length > 0) {
		mozless_focusedFrameIndex = 0;
		window._content.frames[mozless_focusedFrameIndex].focus();
	} else {
		mozless_focusedFrameIndex = null;
	}
}

//////////////////////////////////////////////////////////////////////
//
// key event handling
//

window.addEventListener("keypress", mozless_onkeypress, false);

function mozless_onkeypress(e)
{
    if (!mozless_enabled) return;

    if (!mozless_finding() && mozless_is_normal_target(e)) {
	if (mozless_do_mapping(e)) e.preventDefault();
    }
}

function mozless_is_normal_target(e)
{
    return !mozless_detect_form(e) && !mozless_detect_designmode(e);
}

function mozless_finding()
{
    if (!mozless_isFirefox) return false;
    else return !document.getElementById("FindToolbar").hidden;
}

function mozless_detect_form(e)
{
    return /^(input|textarea|textbox|select)$/i
	.test(Components.lookupMethod(e.originalTarget, 'localName')
	      .call(e.originalTarget));
}

function mozless_detect_designmode(e)
{
    var doc = Components.lookupMethod
	(e.originalTarget, 'ownerDocument').call(e.originalTarget);
    return Components.lookupMethod(doc, 'designMode').call(doc) == 'on';
}

function mozless_do_mapping(e)
{

    // char code

    if (!e.altKey && !e.ctrlKey && !e.metaKey)
	switch (String.fromCharCode(e.charCode)) {

	case 'o':
	    mozless_function_focus_mode();
	    return true;
	case 'k':
	    mozless_function_previous();
	    return true;
	case 'j':
	    mozless_function_next();
	    return true;
	case 'h':
	    mozless_function_back();
	    return true;
	case 'l':
	    mozless_function_forward();
	    return true;
	case 'u':
	    if (!mozless_swapuandi) mozless_function_half_page_up(e);
	    else mozless_function_half_page_down(e);
	    return true;
	case 'i':
	    if (!mozless_swapuandi) mozless_function_half_page_down(e);
	    else mozless_function_half_page_up(e);
	    return true;
	case 'b':
	    mozless_function_page_up();
	    return true;
	case 'f':
	    mozless_function_page_down();
	    return true;
	case ' ':
	    mozless_function_page_down();
	    return true;
	case 'd':
	    mozless_function_half_page_down(e);
	    return true;
	case 'g':
	    mozless_function_top();
	    return true;
	case 'v':
	    mozless_function_open_bookmarks();
	    return true;
	case 'n':
	    findNext();
	    return true;
	case 'q':
	    BrowserCloseTabOrWindow();
	    return true;
	case 't':
	    mozless_function_new_tab();
	    return true;
	case 'm':
	    mozless_function_previous_tab();
	    return true;
	case ',':
	    mozless_function_next_tab();
	    return true;
	case '.':
	    mozless_function_open_tab();
	    return true;
	case 'w':
	    mozless_function_previous_frame();
	    return true;
	case 'e':
	    mozless_function_next_frame();
	    return true;

	case 'G':
	    mozless_function_bottom();
	    return true;
	case 'B':
	    BrowserBack();
	    return true;
	case 'F':
	    BrowserForward();
	    return true;
	case 'R':
	    BrowserReload();
	    return true;
	case 'S':
	    BrowserStop();
	    return true;
	case 'H':
	    BrowserHome();
	    return true;
	case 'U':
	    openLocation();
	    return true;
	case 'N':
	    findPrevious();
	    return true;
	case 'Q':
	    BrowserCloseWindow();
	    return true;

	}

    // key code

    if (!e.altKey && !e.ctrlKey && !e.metaKey && !e.shiftKey)
	switch (e.keyCode) {

	case e.DOM_VK_UP:
	    mozless_function_previous();
	    return true;
	case e.DOM_VK_DOWN:
	    mozless_function_next();
	    return true;
	case e.DOM_VK_LEFT:
	    mozless_function_back();
	    return true;
	case e.DOM_VK_RIGHT:
	    mozless_function_forward();
	    return true;
	case e.DOM_VK_HOME:
	    mozless_function_top();
	    return true;
	case e.DOM_VK_END:
	    mozless_function_bottom();
	    return true;
	case e.DOM_VK_PAGE_UP:
	    mozless_function_page_up();
	    return true;
	case e.DOM_VK_PAGE_DOWN:
	    mozless_function_page_down();
	    return true;

	}

    // control mode

    if (!e.altKey && e.ctrlKey && !e.metaKey) {
	switch (String.fromCharCode(e.charCode)) {

	case 'p':
	    if (mozless_emacskeys) {
		mozless_function_previous();
		return true;
	    } else {
		return false;
	    }
	case 'n':
	    if (mozless_emacskeys) {
		mozless_function_next();
		return true;
	    } else {
		return false;
	    }
	case 'b':
	    if (mozless_emacskeys) {
		mozless_function_back();
		return true;
	    } else {
		return false;
	    }
	case 'f':
	    if (mozless_emacskeys) {
		mozless_function_forward();
		return true;
	    } else {
		return false;
	    }
	case 'j':
	    if (mozless_emacskeys) {
		mozless_function_next();
		return true;
	    } else {
		return false;
	    }
	case 'v':
	    if (mozless_emacskeys) {
		mozless_function_page_down();
		return true;
	    } else {
		return false;
	    }

	}
    }

    return false;
}

//////////////////////////////////////////////////////////////////////
//
// functions
//

function mozless_function_focus_mode()
{
    mozless_focusMode = !mozless_focusMode;

    if (mozless_crossfire) mozless_crossfire_update();
}

function mozless_function_previous()
{
    if (mozless_focusMode) { if (!mozless_crossfire) mozless_focusPrev(); }
    else { goDoCommand('cmd_scrollLineUp'); }
}

function mozless_function_next()
{
    if (mozless_focusMode) { if (!mozless_crossfire) mozless_focusNext(); }
    else { goDoCommand('cmd_scrollLineDown'); }
}

function mozless_function_back()
{
    if (mozless_focusMode) { if (!mozless_crossfire) BrowserBack(); }
    else { goDoCommand('cmd_scrollLeft'); }
}

function mozless_followLink()
{
    var focus = document.commandDispatcher.focusedElement;
    if (!focus) return;
    window._content.open(focus.href, "_self");
}

function mozless_function_forward()
{
    if (mozless_focusMode) { if (!mozless_crossfire) mozless_followLink(); }
    else { goDoCommand('cmd_scrollRight'); }
}

function mozless_function_page_up()
{
    goDoCommand('cmd_scrollPageUp');
    if (mozless_focusMode) mozless_focusBottom();
}

function mozless_function_page_down()
{
    goDoCommand('cmd_scrollPageDown');
    if (mozless_focusMode) mozless_focusTop();
}

function mozless_function_half_page_up(e)
{
    /*
    var focus = document.commandDispatcher.focusedElement;
    if (focus == null) {
	if (mozless_focusedFrameIndex != null) {
	    var w = window._content.frames[mozless_focusedFrameIndex]
		.document.defaultView;
	    w.scrollBy(0, -w.innerHeight/2);
	} else if (window._content.frames.length > 0) {
	    for (var i=0; i<window._content.frames.length; i++) {
		var w = window._content.frames[i].document.defaultView;
		w.scrollBy(0, -w.innerHeight/2);
	    }
	} else {
	    window._content.scrollBy(0, -window._content.innerHeight/2);
	}
    } else {
	var w = focus.ownerDocument.defaultView;
	w.scrollBy(0, -w.innerHeight/2);
    }
    */

    var w = Components.lookupMethod(e.originalTarget, 'ownerDocument')
	.call(e.originalTarget).defaultView;
    w.scrollBy(0, -w.innerHeight/2);

    if (mozless_focusMode) mozless_focusBottom();
}

function mozless_function_half_page_down(e)
{
    /*
    var focus = document.commandDispatcher.focusedElement;
    if (focus == null) {
	if (mozless_focusedFrameIndex != null) {
	    var w = window._content.frames[mozless_focusedFrameIndex]
		.document.defaultView;
	    w.scrollBy(0, w.innerHeight/2);
	} else if (window._content.frames.length > 0) {
	    for (var i=0; i<window._content.frames.length; i++) {
		var w = window._content.frames[i].document.defaultView;
		w.scrollBy(0, w.innerHeight/2);
	    }
	} else {
	    window._content.scrollBy(0, window._content.innerHeight/2);
	}
    } else {
	var w = focus.ownerDocument.defaultView;
	w.scrollBy(0, w.innerHeight/2);
    }
    */

    var focus = document.commandDispatcher.focusedElement;
    if (focus == null) {
	var w = Components.lookupMethod(e.originalTarget, 'ownerDocument')
	    .call(e.originalTarget).defaultView;
	w.scrollBy(0, w.innerHeight/2);
    } else {
	var w = focus.ownerDocument.defaultView;
	w.scrollBy(0, w.innerHeight/2);
    }

    if (mozless_focusMode) mozless_focusTop();
}

function mozless_function_top()
{
    goDoCommand('cmd_scrollTop');
    if (mozless_focusMode) mozless_focusTop();
}

function mozless_function_bottom()
{
    goDoCommand('cmd_scrollBottom');
    if (mozless_focusMode) mozless_focusBottom();
}

function mozless_function_open_bookmarks()
{
    var dirService = Components
	.classes['@mozilla.org/file/directory_service;1']
	.getService(Components.interfaces.nsIProperties);

    const NS_APP_USER_PROFILE_50_DIR = "ProfD";
    profileDir = dirService.get
	(NS_APP_USER_PROFILE_50_DIR, Components.interfaces.nsIFile);

    var bookmarksURL = "file://" + profileDir.path + "/bookmarks.html";
    window._content.open(bookmarksURL, "_self");
}

function mozless_function_new_tab()
{
    var homePage = gHomeButton.getHomePage();
    delayedOpenTab(homePage);
}

// NOTE: delta must be small :)
function mozless_tabRelativeSelect(delta)
{
    var oldTab = gBrowser.selectedTab;
    var newTab = null;
    var length = gBrowser.tabContainer.childNodes.length;
    var index;
    for (index=0; index<length; index++) {
	if (gBrowser.tabContainer.childNodes[index] == oldTab) {
	    var new_index = index + delta;
	    if (new_index < 0) new_index += length;
	    else if (new_index >= length) new_index -= length;
	    newTab = gBrowser.tabContainer.childNodes[new_index];
	    break;
	}
    }
    if (newTab && newTab != oldTab)
	gBrowser.selectedTab = newTab;
}

function mozless_function_previous_tab()
{
    mozless_tabRelativeSelect(-1);
}

function mozless_function_next_tab()
{
    mozless_tabRelativeSelect(+1);
}

function mozless_function_open_tab()
{
    var focus = document.commandDispatcher.focusedElement;
    if (!focus) return;
    gBrowser.selectedTab = gBrowser.addTab(focus.href);
}

function mozless_function_previous_frame()
{
    if (window._content.frames.length > 0) {
	if (mozless_focusedFrameIndex == null) {
	    mozless_focusedFrameIndex = 0;
	} else {
	    mozless_focusedFrameIndex--;
	    if (mozless_focusedFrameIndex < 0)
		mozless_focusedFrameIndex = window._content.frames.length - 1;
	}
	window._content.frames[mozless_focusedFrameIndex].focus();
    }
}

function mozless_function_next_frame()
{
    if (window._content.frames.length > 0) {
	if (mozless_focusedFrameIndex == null) {
	    mozless_focusedFrameIndex = 0;
	} else {
	    mozless_focusedFrameIndex++;
	    if (mozless_focusedFrameIndex >= window._content.frames.length)
		mozless_focusedFrameIndex = 0;
	}
	window._content.frames[mozless_focusedFrameIndex].focus();
    }
}

//
//
//
//////////////////////////////////////////////////////////////////////

window.addEventListener("load", mozless_init, true);

function mozless_getBoolPref(prefs, name, d)
{
	if (prefs.prefHasUserValue(name))
		return prefs.getBoolPref(name);
	else
		return d;
}

function mozless_getIntPref(prefs, name, d)
{
	if (prefs.prefHasUserValue(name))
		return prefs.getIntPref(name);
	else
		return d;
}

function mozless_getCharPref(prefs, name, d)
{
	if (prefs.prefHasUserValue(name))
		return prefs.getCharPref(name);
	else
		return d;
}

MozlessPrefsObserver.prototype =
{
  observe:
    function(subject, topic, data) {
      mozless_init_settings();
    }
}

var mozless_prefs_observer = new MozlessPrefsObserver();

function MozlessPrefsObserver()
{
  try {
    var prefs = Components.classes["@mozilla.org/preferences-service;1"]
      .getService(Components.interfaces.nsIPrefService)
      .getBranch(null);
    var pbi = prefs.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
    pbi.addObserver("extensions.mozless", this, false);
  } catch (e) {
    alert(e);
  }
}

function mozless_getAppName()
{
	var name = null;

	try {
		var info = Components.classes["@mozilla.org/xre/app-info;1"]
			.getService(Components.interfaces.nsIXULAppInfo);
		name = info.name;
	} catch (e) { }

	return name;
}

function mozless_focusTop() {
  var focus = document.commandDispatcher.focusedElement;
  if (focus) {
    var w = window._content;
    if (focus.offsetTop >= w.pageYOffset && focus.offsetTop - w.pageYOffset < w.innerHeight) {
      return;
    }
  }

  var w = window._content;
  var links = w.document.links;
  for (var i=0; i<links.length; i++) {
    if (links[i].offsetTop >= w.pageYOffset
	&& links[i].offsetTop < w.pageYOffset + w.innerHeight) {
      links[i].focus();
      links[i].select();
      return;
    }
  }
}

function mozless_focusBottom()
{
  var focus = document.commandDispatcher.focusedElement;
  if (focus) {
    var w = window._content;
    if (focus.offsetTop >= w.pageYOffset && focus.offsetTop - w.pageYOffset < w.innerHeight) {
      return;
    }
  }

  var w = window._content;
  var links = w.document.links;
  for (var i=links.length-1; i>=0; i--) {
    if (links[i].offsetTop < w.pageYOffset + w.innerHeight
	&& links[i].offsetTop >= w.pageYOffset) {
      links[i].focus();
      links[i].select();
      return;
    }
  }
}

function mozless_focusPrev() {
  var focus = document.commandDispatcher.focusedElement;
  if (!focus) {
    mozless_focusBottom();
    return;
  }
  var w = window._content;
  if (focus.offsetTop < w.pageYOffset || focus.offsetTop - w.pageYOffset >= w.innerHeight) {
    // XXX - Horizontal restrictions may be required.
    mozless_focusBottom();
  }
  var links = w.document.links;
  for (var i=links.length-1; i>=0; i--) {
    if (links[i] == focus) {
      if (i-1 >= 0) {
	links[i-1].focus();
	links[i-1].select();
      }
      return;
    }
  }
}

function mozless_focusNext() {
  var focus = document.commandDispatcher.focusedElement;
  if (!focus) {
    mozless_focusTop();
    return;
  }
  var w = window._content;
  if (focus.offsetTop < w.pageYOffset || focus.offsetTop - w.pageYOffset >= w.innerHeight) {
    // XXX - Horizontal restrictions may be required.
    mozless_focusTop();
  }
  var links = w.document.links;
  for (var i=0; i<links.length; i++) {
    if (links[i] == focus) {
      if (i+1 < links.length) {
	links[i+1].focus();
	links[i+1].select();
      }
      return;
    }
  }
}

// setting menu for Mozilla Suite

function mozless_settings()
{
    var dialog = window.openDialog
	("chrome://mozless/content/mozlessPrefDialog.xul",
	 null, "modal, centerscreen");
}
