var mozless_sb;

function initMozlessPrefs() {
	var sbs = Components.classes["@mozilla.org/intl/stringbundle;1"].
		getService(Components.interfaces.nsIStringBundleService);
	mozless_sb = sbs.createBundle("chrome://mozless/locale/messages.properties");

  document.getElementById("prefMozlessClear").checked = false;

	{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"]
		.getService(Components.interfaces.nsIPrefService)
		.getBranch("extensions.mozless.");

  document.getElementById("prefMozlessEnabled").checked
    = mozless_getBoolPref(prefs, "enabled", true);
  document.getElementById("prefMozlessDebug").checked
    = mozless_getBoolPref(prefs, "debug", false);
  document.getElementById("prefMozlessFocusMode").checked
    = mozless_getBoolPref(prefs, "focusmode", false);
  document.getElementById("prefMozlessEmacsKeys").checked
		= mozless_getBoolPref(prefs, "emacskeys", false);
  document.getElementById("prefMozlessSwapUAndI").checked
		= mozless_getBoolPref(prefs, "swapuandi", false);
  document.getElementById("prefMozlessCrossFire").checked
		= mozless_getBoolPref(prefs, "crossfire", false);
	}
}

function mozless_getBoolPref(prefs, name, d)
{
	if (prefs.prefHasUserValue(name))
		return prefs.getBoolPref(name);
	else
		return d;
}

function mozless_getIntPref(prefs, name, d)
{
	if (prefs.prefHasUserValue(name))
		return prefs.getIntPref(name);
	else
		return d;
}

function mozless_getCharPref(prefs, name, d)
{
	if (prefs.prefHasUserValue(name))
		return prefs.getCharPref(name);
	else
		return d;
}

function mozless_getAppName()
{
	var name = null;

	try {
		var info = Components.classes["@mozilla.org/xre/app-info;1"]
			.getService(Components.interfaces.nsIXULAppInfo);
		name = info.name;
	} catch (e) { }

	return name;
}

function changeMozlessPrefs() {
	if (document.getElementById("prefMozlessClear").checked) {
		clearMozlessPrefs();
		mozless_settings_clear_typeaheadfind();
	} else {
		updateMozlessPrefs();
		if (!document.getElementById("prefMozlessEnabled").checked)
			mozless_settings_clear_typeaheadfind();
		else
			mozless_settings_update_typeaheadfind();
	}
}

function updateMozlessPrefs()
{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"]
		.getService(Components.interfaces.nsIPrefService)
		.getBranch("extensions.mozless.");

	prefs.setBoolPref("enabled",
		document.getElementById("prefMozlessEnabled").checked);
	prefs.setBoolPref("debug",
		document.getElementById("prefMozlessDebug").checked);
	prefs.setBoolPref("focusmode",
		document.getElementById("prefMozlessFocusMode").checked);
	prefs.setBoolPref("emacskeys", 
		document.getElementById("prefMozlessEmacsKeys").checked);
	prefs.setBoolPref("swapuandi", 
		document.getElementById("prefMozlessSwapUAndI").checked);
	prefs.setBoolPref("crossfire", 
		document.getElementById("prefMozlessCrossFire").checked);
}

function clearMozlessPrefs()
{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"]
		.getService(Components.interfaces.nsIPrefService)
		.getBranch("extensions.mozless.");

	try {
		prefs.clearUserPref("enabled");
	} catch (e) { }
	try {
		prefs.clearUserPref("debug");
	} catch (e) { }
	try {
		prefs.clearUserPref("focusmode");
	} catch (e) { }
	try {
		prefs.clearUserPref("emacskeys");
	} catch (e) { }
	try {
		prefs.clearUserPref("swapuandi");
	} catch (e) { }
	try {
		prefs.clearUserPref("crossfire");
	} catch (e) { }
}

function mozless_settings_update_typeaheadfind()
{
	;
}

function mozless_settings_clear_typeaheadfind()
{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"]
		.getService(Components.interfaces.nsIPrefBranch);

	var autostart = prefs.getBoolPref("accessibility.typeaheadfind.autostart");
	var linksonly = prefs.getBoolPref("accessibility.typeaheadfind.linksonly");

	try {
		prefs.clearUserPref("accessibility.typeaheadfind.autostart");
	} catch (e) { }
	try {
		prefs.clearUserPref("accessibility.typeaheadfind.linksonly");
	} catch (e) { }

	if (prefs.getBoolPref("accessibility.typeaheadfind.autostart") != autostart)
		if (mozless_getAppName() != "Firefox")
			alert(mozless_sb.GetStringFromName("autostart_is_cleared")
				+ " (accessibility.typeaheadfind.autostart = default)");
	if (prefs.getBoolPref("accessibility.typeaheadfind.linksonly") != linksonly)
		alert(mozless_sb.GetStringFromName("linksonly_is_cleared")
			+ " (accessibility.typeaheadfind.linksonly = default)");
}
